]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: Check completion for `bg`, `fg`, `jobs` and `unset`
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60 if test -n "$BASH_VERSION"; then
61    [ "`type -t ls`" = alias ] && unalias ls
62    [ "`type -t ll`" = alias ] && unalias ll
63    [ "`type -t mc`" = alias ] && unalias mc
64
65    back() { cd - "$@"; }
66    functions() { typeset -f "$@"; }
67    j() { jobs; }
68
69    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
70       if [ -d /usr/share/bash-completion -a -r /usr/share/bash-completion/bash_completion ]; then
71          _BASH_COMPLETIONS_DIR=/usr/share/bash-completion/completions
72          . /usr/share/bash-completion/bash_completion
73       elif [ -r /etc/bash_completion ]; then
74          _BASH_COMPLETIONS_DIR=/etc/bash_completion.d
75          . /etc/bash_completion
76       elif [ -d /etc/bash_completion.d ]; then
77          _BASH_COMPLETIONS_DIR=/etc/bash_completion.d
78          for _compf in /etc/bash_completion.d/*; do
79             . $_compf
80          done
81       elif [ -d /usr/local/etc/bash_completion.d ]; then
82          _BASH_COMPLETIONS_DIR=/usr/local/etc/bash_completion.d
83          for _compf in /usr/local/etc/bash_completion.d/*; do
84             . $_compf
85          done
86       else
87          echo "Unknown OS type, cannot source bash_completion" >&2
88       fi
89    fi
90
91    has_completion() {
92       [ -n "$_BASH_COMPLETIONS_DIR" -a -d "$_BASH_COMPLETIONS_DIR" -a -r "$_BASH_COMPLETIONS_DIR/$1" ] ||
93       complete -p $1 >/dev/null 2>&1
94    }
95
96    for cmd in builtin cgmem_nice command dbus-launch exec \
97          killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg \
98          run-all-hosts su sudo time whence whereis which xargs; do
99       ! has_completion $cmd && complete -o default -A command $cmd
100    done
101
102    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
103          telnet t tt \
104          tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
105          whois wd wget wget-download wget-m wget-wrapper ww; do
106       ! has_completion $cmd && complete -A hostname $cmd
107    done
108
109    for cmd in distribute ftp lftp r rsync \
110          s scp ssh smbclient tcpdump tshark wireshark; do
111       ! has_completion $cmd && complete -o default -A hostname $cmd
112    done
113
114    for cmd in bg fg jobs; do
115       ! has_completion $cmd && complete -A job $cmd
116    done
117
118    complete -A job j wait
119
120    for cmd in unset; do
121       ! has_completion $cmd && complete -A variable -A function $cmd
122    done
123
124    if [ -d "$HOME"/.bash_completion.d ]; then
125       for _compf in "$HOME"/.bash_completion.d/*; do
126          . $_compf
127       done
128    fi
129
130    delegate_completion() {
131       local prog programs
132       prog=$1
133       if has_completion $prog; then
134          shift
135          programs="$@"
136          eval "_${prog}_completion_loader() {
137             _completion_loader $prog
138             complete -o nospace -F _$prog $programs
139             unset _${prog}_completion_loader
140             return 124
141          }"
142          complete -F _${prog}_completion_loader $programs
143       fi
144    }
145
146    delegate_completion make m
147    delegate_completion ping p
148    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
149    delegate_completion ssh s
150    delegate_completion wget wget-m wget-wrapper ww
151
152    unset _BASH_COMPLETIONS_DIR has_completion delegate_completion
153
154    if [ -d "$HOME/lib/config" ]; then
155       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
156    fi
157    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
158
159    if [ "`type -t short_curdir`" != function -a \
160          -r "$HOME"/admin/prog/bash_prompt ]; then
161       . "$HOME"/admin/prog/bash_prompt
162    fi
163
164    #if type -p pip >/dev/null 2>&1; then
165    #   eval "`pip completion --bash`"
166    #   rm -rf /tmp/pip_build_"$USER"
167    #fi
168
169    #if which pyenv >/dev/null 2>&1; then
170    #   eval "`pyenv init -`"
171    #   eval "`pyenv virtualenv-init -`"
172    #fi
173
174    . virtualenvwrapper_lazy.sh 2>/dev/null
175
176    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
177       . "$VIRTUAL_ENV/bin/activate"
178    fi
179
180    # Clean up python virtual environment on exit
181    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
182
183    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
184
185 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
186    back() { cd - "$@"; }
187    j() { jobs; }
188 fi
189
190 PS1="$OPS1"
191
192 # clear screen and history, logout
193 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
194
195
196 if test -x /usr/bin/git >/dev/null 2>&1; then
197    # chdir to a directory
198    cdgitpath() {
199       if [ $# -ne 1 ]; then
200          echo "Usage: cdgitpath path_key" >&2
201          return 1
202       fi
203
204       path_key="$1"
205       if [ -z "$path_key" ]; then
206          echo "Usage: cdgitpath path_key" >&2
207          return 1
208       fi
209
210       path_url="`git config --get --path $path_key`"
211       if echo "$path_url" | grep -q '^file:/'; then
212          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
213       fi
214       cd "$path_url"
215    }
216
217    # chdir to a remote's directory (if the remote is on the local FS)
218    cdremote() {
219       if [ $# -gt 1 ]; then
220          echo "Usage: cdremote [remote_name]" >&2
221          return 1
222       fi
223
224       if [ -z "$1" ]; then
225          branch="`git rev-parse --abbrev-ref HEAD`"
226          remote="`git config --get branch.$branch.remote`"
227       else
228          remote="$1"
229       fi
230
231       if [ -n "$remote" ] && git config --get remote.$remote.url |
232             grep -q '^\(file:/\|/\|\.\./\)'; then # (file:/ or / or ../ at the beginning)
233          cdgitpath remote.$remote.url
234       else
235
236          if [ -n "$1" ]; then
237             echo "Cannot find directory for remote $1" >&2
238             echo "Usage: cdremote [remote_name]" >&2
239             return 1
240          fi
241
242          if test -n "$BASH_VERSION"; then
243             _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
244             if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
245                remote=${GIT_REMOTES[0]}
246                unset GIT_REMOTES
247                cdgitpath remote.$remote.url
248             else
249                unset GIT_REMOTES
250                echo "Cannot find directory for any remote" >&2
251                echo "Usage: cdremote [remote_name]" >&2
252                return 1
253             fi
254          else
255             echo "Cannot find directory for remote $1" >&2
256             echo "Usage: cdremote [remote_name]" >&2
257             return 1
258          fi
259       fi
260    }
261
262    if test -n "$BASH_VERSION"; then
263       # completion for aliases in global .gitconfig
264
265       # fixup rbi rbia rbiap rbip - do refs name completion
266       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
267       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
268       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
269       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
270       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
271       #
272       # push-to-all-remotes - do branch name completion
273       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
274
275       _cdgitpath_complete() {
276          local cur="${COMP_WORDS[COMP_CWORD]}"
277          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
278       }
279
280       _git_open() {
281          _cdgitpath_complete
282       }
283
284       complete -F _cdgitpath_complete cdgitpath git-open
285
286       # list remotes with URLs matching a regexp
287       _list_remotes() {
288          if [ $# -ne 1 ]; then
289             echo "Usage: _list_remotes remote_regexp" >&2
290             return 1
291          fi
292          declare -ag GIT_REMOTES=()
293          local remote
294          for remote in `git remote`; do
295             if git config --get remote.$remote.url | grep -q "$1"; then
296                GIT_REMOTES+=($remote)
297             fi
298          done
299       }
300
301       # completion for cdremote and git-open-remote - list remotes with a pattern
302       _list_remotes_completion() {
303          local cur="${COMP_WORDS[COMP_CWORD]}"
304          _list_remotes "$1"
305          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
306          unset GIT_REMOTES
307       }
308
309       # completion for cdremote - list remotes with directories as URLs
310       _cdremote_complete() {
311          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
312          if [ ${#COMPREPLY[*]} -eq 0 ]; then
313             _list_remotes_completion .
314          fi
315       }
316
317       complete -F _cdremote_complete cdremote
318
319       # completion for git-open-remote - list remotes with http(s) URLs
320       _git_open_remote() {
321          _list_remotes_completion '^http\(s\)\?://'
322          if [ ${#COMPREPLY[*]} -eq 0 ]; then
323             _list_remotes_completion .
324          fi
325       }
326
327       complete -F _git_open_remote git-open-remote
328    fi
329 fi
330
331
332 include() {
333    cfg="$1"
334    if [ -f "./$cfg" -a -r "./$cfg" ]; then
335       echo "Reading config file \`$cfg'" 1>&2
336       . "./$cfg"
337    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
338       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
339       . "$HOME/lib/config/$cfg"
340    else
341       echo "Cannot find config file \`$cfg'" 1>&2
342    fi
343 }
344
345
346 mc() {
347    if test -n "$BASH_VERSION"; then
348       MC_SAVE_OPS1="$OPS1"
349       if [ "`type -t short_curdir`" = function ]; then
350          OPS1="\`cgmem_which_prompt\`\u@\${HOSTNAME::5}:\`short_curdir\` "
351          OPS1+="\$(prompt_git)\\$\$SHLVL "
352       else
353          OPS1="\u@\h:\W \\$"
354       fi
355    fi
356
357    if [ -n "$SLOWTERM" ]; then
358       MC_SLOW="--slow"
359    fi
360
361    case "$TERM" in
362       screen*) # screen, screen.rxvt
363          MC_XTERM="-x"
364       ;;
365    esac
366
367    #TMPDIR="$HOME"/tmp
368    #export TMPDIR
369
370    MC_FOUND=NO
371
372    for wrapper in \
373          /usr/local/share/mc/bin/mc-wrapper.sh \
374          /usr/local/libexec/mc/mc-wrapper.sh \
375          /usr/share/mc/bin/mc-wrapper.sh; do
376       if [ -r $wrapper ]; then
377          . $wrapper $MC_SLOW $MC_XTERM "$@"
378          rc=$?
379          MC_FOUND=YES
380          break
381       fi
382    done
383
384    if [ $MC_FOUND = NO ]; then
385       for mc in /usr/local/bin/mc /usr/bin/mc; do
386          if [ -x $mc ]; then
387             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
388             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
389                MC_TMP_DIR="${TMPDIR-/tmp}"
390             fi
391             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
392             mc_type="`mc_type.py $mc`"
393             if [ "$mc_type" = old ]; then
394                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
395             elif [ "$mc_type" = new ]; then
396                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
397             else
398                continue
399             fi
400             rc=$?
401             MC_FOUND=YES
402             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
403             break
404          fi
405       done
406    fi
407
408    if [ $MC_FOUND = NO ]; then
409       echo "Cannot find mc-wrapper.sh or mc" >&2
410       rc=1
411    fi
412
413    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
414    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
415
416    return $rc
417 }
418
419
420 mkcd() {
421    if [ $# -ne 1 ]; then
422       echo "Usage: mkcd directory_name" >&2
423    elif [ -d "$1" ]; then
424       cd "$1"
425    elif [ -e "$1" ]; then
426       echo "Error: $1 is a file" >&2
427    else
428       mkdir -p "$1" && cd "$1"
429    fi
430 }
431
432
433 if which tmux >/dev/null 2>&1; then
434    tmux() {
435       case "$TERM" in
436          rxvt)
437             TERM=rxvt-unicode command tmux "$@"
438          ;;
439
440          *)
441             command tmux "$@"
442          ;;
443       esac
444    }
445 fi
446
447
448 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
449    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
450 fi
451
452 x() { exit; }